/************************************************************************* 
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005,2007  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

class Microscreen : public Device
{
	SDL_Surface *m_video;
	SDL_Surface *m_uscreen;
	SDL_Surface *m_led[2];
	int m_x, m_y;
	int m_clickkey;
	bool m_visible;
	bool m_showTime;
	int m_curx, m_cury, m_curShown;
	char m_data[2][40];
	Uint32 m_fg, m_bg;

	void clearData();

public:
	Microscreen(SDL_Surface *video);
	virtual ~Microscreen();

	virtual void reset();
	virtual bool parseNode(xmlDoc*, xmlNs*, xmlNode*);
	virtual bool storeNode(xmlDoc*, xmlNs*, xmlNode*);


	void repaint(int x, int y, int w, int h);
	void updateChar(SDL_Surface *s, int x, int y, char c, bool bCursor);
	void updateText(SDL_Surface *s, int x, int y, int chx = -1, int chy = -1);
	void updateLEDs(SDL_Surface *s, int x, int y);

	void setCurPos(int x, int y);
	void curLeft();
	void curRight();
	void setLEDs(u_int8 value);
	void addChar(u_int8 ch);
	void showCur(void);
	void hideCur(void);
	void setVisible(bool b);
	void clear();
	void setTime(bool bShowTime);
	void updateTime();

	UiEvent handleEvent(SDL_Event *e, int *key);

	int m_ledValue;
};


