/************************************************************************

    QDAE v0.0.2 - Quick And Dirty Apricot emulator

    Copyright (C) 2005  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/


enum QdaeFileType
{
	FT_NORMAL,	// QDAE data path root
	FT_BITMAPS,	// Bitmap images
	FT_ROM,		// ROMs
	FT_DISC,	// non-boot discs
	FT_PNGS,	// PNG output files
	FT_PS,		// Postscript output files
	FT_KEYBOARD,	// Keyboard layouts
};


char *name_from_path(char *s);
string getHomeRoot(void);
string getHomeDir(void);
void setHomeDir(string s);
string getLibDir(void);
void checkExistsDir(const string path);
string findQdaeDir(QdaeFileType t, bool global);
string findQdaeFile(QdaeFileType ft, const string name, const string mode);
FILE  *openQdaeFile(QdaeFileType ft, const string name, const string mode);
string displayName (string filename, int len);
FILE *openTemp(char *name, const string type, const string mode);



