/************************************************************************* 
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005-7  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/


class XI_ENV;
class Microscreen;

class XI_Keyboard : public Keyboard, public SerialListener
{
	int m_state;
	int m_mousex, m_mousey;
	bool m_mouseEnabled;
	Microscreen *m_uscreen;
public:
	XI_Keyboard(XI_ENV *m);
	virtual ~XI_Keyboard();

	virtual UiEvent keyboard_event(SDL_Event *e);

	void send_mouse(int btns, int x, int y);

	virtual void send_time();
	virtual void reset();
	void encode_mouse(int btns, signed dx, signed dy);

	virtual void receive(SerialChannel *ch);

	inline void setMicroscreen(Microscreen *ms) { m_uscreen = ms; }
	inline Microscreen *getMicroscreen() { return m_uscreen; }
};

