/************************************************************************* 
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005,2007  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "microscreen.hxx"
#include "crtc.hxx"

class XI_Video : public Video
{
	u_int16 shadowchar[25][80];
	u_int8 *sysram;
	int vscale;
	int v_mode;
	int scr_rows;
	Uint32 m_bg, m_fg, m_bright;
	SDL_Colour m_clrbg, m_clrfg, m_clrbr;
	bool m_text_mode;
	u_int16 m_base, m_curaddr;
	int m_curcount, m_curmax, m_curtop, m_curbot, m_curmode;
	CRTC m_crtc;
	Microscreen *m_uscreen;

	UiEvent customClrs(UiDrawer *d);

public:
	XI_Video(PC_ENV *m);
	virtual ~XI_Video();

	inline Microscreen *getMicroscreen()
	{
		return m_uscreen;
	}

	void write(u_int16 port, u_int8 value);
	u_int8 read(u_int16 port);

	void paint_text(int y, int x, Uint16 ch, bool cursor);
	void paint_gfx(int y, int x, Uint16 ch);

	virtual int paint();
	virtual void init();

	void setTextMode(bool text);

	virtual bool parseNode(xmlDoc *doc, xmlNs *ns, xmlNode *node);
	virtual bool storeNode(xmlDoc *doc, xmlNs *ns, xmlNode *node);
	virtual UiEvent settings(UiDrawer *d);
	virtual bool hasSettings(SDLKey *key, string &caption);
};

